/* DO NOT EDIT: automatically built by format/config.sh. */

#pragma once

#define C_TYPE_MATCH(cp, type)                                                                    \
    (!F_ISSET(cp, (C_TYPE_FIX | C_TYPE_ROW | C_TYPE_VAR)) ||                                      \
      ((type) == FIX && F_ISSET(cp, C_TYPE_FIX)) || ((type) == ROW && F_ISSET(cp, C_TYPE_ROW)) || \
      ((type) == VAR && F_ISSET(cp, C_TYPE_VAR)))

typedef struct {
    const char *name; /* Configuration item */
    const char *desc; /* Configuration description */

#define C_BOOL 0x001u        /* Boolean (true if roll of 1-to-100 is <= CONFIG->min) */
#define C_IGNORE 0x002u      /* Not a simple randomization, configured specially */
#define C_STRING 0x004u      /* String (rather than integral) */
#define C_TABLE 0x008u       /* Value is per table, not global */
#define C_TYPE_FIX 0x010u    /* Value is only relevant to FLCS */
#define C_TYPE_LSM 0x020u    /* Value is only relevant to LSM */
#define C_TYPE_ROW 0x040u    /* Value is only relevant to RS */
#define C_TYPE_VAR 0x080u    /* Value is only relevant to VLCS */
#define C_ZERO_NOTSET 0x100u /* Ignore zero values */
    uint32_t flags;

    uint32_t min;     /* Minimum value */
    uint32_t maxrand; /* Maximum value randomly chosen */
    uint32_t maxset;  /* Maximum value explicitly set */

    u_int off; /* Value offset */
} CONFIG;

#define V_MAX_TABLES_CONFIG WT_THOUSAND

#define V_GLOBAL_ASSERT_READ_TIMESTAMP 0
#define V_GLOBAL_BACKGROUND_COMPACT 1
#define V_GLOBAL_BACKGROUND_COMPACT_FREE_SPACE_TARGET 2
#define V_GLOBAL_BACKUP 3
#define V_GLOBAL_BACKUP_INCREMENTAL 4
#define V_GLOBAL_BACKUP_INCR_GRANULARITY 5
#define V_GLOBAL_BLOCK_CACHE 6
#define V_GLOBAL_BLOCK_CACHE_CACHE_ON_CHECKPOINT 7
#define V_GLOBAL_BLOCK_CACHE_CACHE_ON_WRITES 8
#define V_GLOBAL_BLOCK_CACHE_SIZE 9
#define V_TABLE_BTREE_BITCNT 10
#define V_TABLE_BTREE_COMPRESSION 11
#define V_TABLE_BTREE_DICTIONARY 12
#define V_TABLE_BTREE_INTERNAL_KEY_TRUNCATION 13
#define V_TABLE_BTREE_INTERNAL_PAGE_MAX 14
#define V_TABLE_BTREE_KEY_MAX 15
#define V_TABLE_BTREE_KEY_MIN 16
#define V_TABLE_BTREE_LEAF_PAGE_MAX 17
#define V_TABLE_BTREE_MEMORY_PAGE_MAX 18
#define V_TABLE_BTREE_PREFIX_LEN 19
#define V_TABLE_BTREE_PREFIX_COMPRESSION 20
#define V_TABLE_BTREE_PREFIX_COMPRESSION_MIN 21
#define V_TABLE_BTREE_REPEAT_DATA_PCT 22
#define V_TABLE_BTREE_REVERSE 23
#define V_TABLE_BTREE_SPLIT_PCT 24
#define V_TABLE_BTREE_VALUE_MAX 25
#define V_TABLE_BTREE_VALUE_MIN 26
#define V_GLOBAL_BUFFER_ALIGNMENT 27
#define V_GLOBAL_CACHE 28
#define V_GLOBAL_CACHE_EVICT_MAX 29
#define V_GLOBAL_CACHE_EVICTION_DIRTY_TARGET 30
#define V_GLOBAL_CACHE_EVICTION_DIRTY_TRIGGER 31
#define V_GLOBAL_CACHE_MINIMUM 32
#define V_GLOBAL_CACHE_MAXIMUM 33
#define V_GLOBAL_CHECKPOINT 34
#define V_GLOBAL_CHECKPOINT_LOG_SIZE 35
#define V_GLOBAL_CHECKPOINT_WAIT 36
#define V_GLOBAL_CHUNK_CACHE 37
#define V_GLOBAL_CHUNK_CACHE_CAPACITY 38
#define V_GLOBAL_CHUNK_CACHE_CHUNK_SIZE 39
#define V_GLOBAL_CHUNK_CACHE_STORAGE_PATH 40
#define V_GLOBAL_CHUNK_CACHE_TYPE 41
#define V_GLOBAL_COMPACT_FREE_SPACE_TARGET 42
#define V_GLOBAL_DEBUG_BACKGROUND_COMPACT 43
#define V_GLOBAL_DEBUG_CHECKPOINT_RETENTION 44
#define V_GLOBAL_DEBUG_CURSOR_REPOSITION 45
#define V_GLOBAL_DEBUG_EVICTION 46
#define V_GLOBAL_DEBUG_LOG_RETENTION 47
#define V_GLOBAL_DEBUG_REALLOC_EXACT 48
#define V_GLOBAL_DEBUG_REALLOC_MALLOC 49
#define V_GLOBAL_DEBUG_SLOW_CHECKPOINT 50
#define V_GLOBAL_DEBUG_TABLE_LOGGING 51
#define V_GLOBAL_DEBUG_UPDATE_RESTORE_EVICT 52
#define V_TABLE_DISK_CHECKSUM 53
#define V_GLOBAL_DISK_DATA_EXTEND 54
#define V_GLOBAL_DISK_DIRECT_IO 55
#define V_GLOBAL_DISK_ENCRYPTION 56
#define V_TABLE_DISK_FIRSTFIT 57
#define V_GLOBAL_DISK_MMAP 58
#define V_GLOBAL_DISK_MMAP_ALL 59
#define V_GLOBAL_FILE_MANAGER_CLOSE_HANDLE_MINIMUM 60
#define V_GLOBAL_FILE_MANAGER_CLOSE_IDLE_TIME 61
#define V_GLOBAL_FILE_MANAGER_CLOSE_SCAN_INTERVAL 62
#define V_GLOBAL_FORMAT_ABORT 63
#define V_GLOBAL_FORMAT_INDEPENDENT_THREAD_RNG 64
#define V_GLOBAL_FORMAT_MAJOR_TIMEOUT 65
#define V_GLOBAL_IMPORT 66
#define V_GLOBAL_LOGGING 67
#define V_GLOBAL_LOGGING_COMPRESSION 68
#define V_GLOBAL_LOGGING_FILE_MAX 69
#define V_GLOBAL_LOGGING_PREALLOC 70
#define V_GLOBAL_LOGGING_REMOVE 71
#define V_TABLE_LSM_AUTO_THROTTLE 72
#define V_TABLE_LSM_BLOOM 73
#define V_TABLE_LSM_BLOOM_BIT_COUNT 74
#define V_TABLE_LSM_BLOOM_HASH_COUNT 75
#define V_TABLE_LSM_BLOOM_OLDEST 76
#define V_TABLE_LSM_CHUNK_SIZE 77
#define V_TABLE_LSM_MERGE_MAX 78
#define V_GLOBAL_LSM_WORKER_THREADS 79
#define V_GLOBAL_OPS_ALTER 80
#define V_GLOBAL_OPS_COMPACTION 81
#define V_GLOBAL_OPS_HS_CURSOR 82
#define V_TABLE_OPS_PARETO 83
#define V_TABLE_OPS_PARETO_SKEW 84
#define V_TABLE_OPS_PCT_DELETE 85
#define V_TABLE_OPS_PCT_INSERT 86
#define V_TABLE_OPS_PCT_MODIFY 87
#define V_TABLE_OPS_PCT_READ 88
#define V_TABLE_OPS_PCT_WRITE 89
#define V_GLOBAL_OPS_BOUND_CURSOR 90
#define V_GLOBAL_OPS_PREPARE 91
#define V_GLOBAL_OPS_RANDOM_CURSOR 92
#define V_GLOBAL_OPS_SALVAGE 93
#define V_GLOBAL_OPS_THROTTLE 94
#define V_GLOBAL_OPS_THROTTLE_SLEEP_US 95
#define V_TABLE_OPS_TRUNCATE 96
#define V_GLOBAL_OPS_VERIFY 97
#define V_GLOBAL_PREFETCH 98
#define V_GLOBAL_QUIET 99
#define V_GLOBAL_RANDOM_DATA_SEED 100
#define V_GLOBAL_RANDOM_EXTRA_SEED 101
#define V_GLOBAL_RUNS_IN_MEMORY 102
#define V_TABLE_RUNS_MIRROR 103
#define V_GLOBAL_RUNS_OPS 104
#define V_GLOBAL_RUNS_PREDICTABLE_REPLAY 105
#define V_TABLE_RUNS_ROWS 106
#define V_TABLE_RUNS_SOURCE 107
#define V_GLOBAL_RUNS_TABLES 108
#define V_GLOBAL_RUNS_THREADS 109
#define V_GLOBAL_RUNS_TIMER 110
#define V_TABLE_RUNS_TYPE 111
#define V_GLOBAL_RUNS_VERIFY_FAILURE_DUMP 112
#define V_GLOBAL_STATISTICS_MODE 113
#define V_GLOBAL_STATISTICS_LOG_SOURCES 114
#define V_GLOBAL_STRESS_AGGRESSIVE_STASH_FREE 115
#define V_GLOBAL_STRESS_AGGRESSIVE_SWEEP 116
#define V_GLOBAL_STRESS_CHECKPOINT 117
#define V_GLOBAL_STRESS_CHECKPOINT_EVICT_PAGE 118
#define V_GLOBAL_STRESS_CHECKPOINT_PREPARE 119
#define V_GLOBAL_STRESS_COMPACT_SLOW 120
#define V_GLOBAL_STRESS_EVICT_REPOSITION 121
#define V_GLOBAL_STRESS_FAILPOINT_EVICTION_SPLIT 122
#define V_GLOBAL_STRESS_FAILPOINT_HS_DELETE_KEY_FROM_TS 123
#define V_GLOBAL_STRESS_HS_CHECKPOINT_DELAY 124
#define V_GLOBAL_STRESS_HS_SEARCH 125
#define V_GLOBAL_STRESS_HS_SWEEP 126
#define V_GLOBAL_STRESS_PREFETCH_DELAY 127
#define V_GLOBAL_STRESS_PREPARE_RESOLUTION_1 128
#define V_GLOBAL_STRESS_SLEEP_BEFORE_READ_OVERFLOW_ONPAGE 129
#define V_GLOBAL_STRESS_SPLIT_1 130
#define V_GLOBAL_STRESS_SPLIT_2 131
#define V_GLOBAL_STRESS_SPLIT_3 132
#define V_GLOBAL_STRESS_SPLIT_4 133
#define V_GLOBAL_STRESS_SPLIT_5 134
#define V_GLOBAL_STRESS_SPLIT_6 135
#define V_GLOBAL_STRESS_SPLIT_7 136
#define V_GLOBAL_STRESS_SPLIT_8 137
#define V_GLOBAL_TIERED_STORAGE_FLUSH_FREQUENCY 138
#define V_GLOBAL_TIERED_STORAGE_STORAGE_SOURCE 139
#define V_GLOBAL_TRANSACTION_IMPLICIT 140
#define V_GLOBAL_TRANSACTION_OPERATION_TIMEOUT_MS 141
#define V_GLOBAL_TRANSACTION_TIMESTAMPS 142
#define V_GLOBAL_WIREDTIGER_CONFIG 143
#define V_GLOBAL_WIREDTIGER_RWLOCK 144
#define V_GLOBAL_WIREDTIGER_LEAK_MEMORY 145

#define V_ELEMENT_COUNT 146
